using System;
using System.Drawing;
using System.Collections;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;
using Syncfusion.Drawing;

namespace ColumnTest
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridGrouping;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();


			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			InitialiseGrid();
			InitialiseModel();
			InitialiseColumns();
			InitialiseEvents();
			InitialiseView();


		}

		private void InitialiseGrid() 
		{

			// Grouping Grid
			gridGrouping = new GridGroupingControl();
			gridGrouping.Name = "priceGrid";
			gridGrouping.DataMember = "";
			gridGrouping.TableOptions.ListBoxSelectionMode = System.Windows.Forms.SelectionMode.MultiExtended;
			gridGrouping.TableOptions.AllowSelection = GridSelectionFlags.Row | GridSelectionFlags.AlphaBlend;
			gridGrouping.TableOptions.AllowDragColumns = true;
			gridGrouping.TableOptions.ShowRowHeader = true;


			this.Controls.Add(gridGrouping);
			gridGrouping.Size = new Size(500, 500);
			this.Size = new Size(550,550);
			this.gridGrouping.Show();

			// Context Menu

		}

		private void InitialiseEvents()
		{
			// Grid Events
			gridGrouping.TableControlCurrentCellChanged += new GridTableControlEventHandler(gridGrouping_TableControlCurrentCellChanged);

		}
		private void InitialiseModel()
		{
			
			ArrayList quotes = new ArrayList();

			for (int i=0; i< 10; i++)
			{	
				Source source = new Source();
				quotes.Add(source);
			}

			gridGrouping.DataSource = quotes;
			gridGrouping.TableDescriptor.AllowNew = true;

		}

		private void InitialiseView()
		{
			// Grid View

			gridGrouping.ThemesEnabled = true;
			gridGrouping.Dock = System.Windows.Forms.DockStyle.Fill;
			gridGrouping.FilterRuntimeProperties = true; // don't show all properties in PropertyGrid
			gridGrouping.TopLevelGroupOptions.ShowCaption = false;
			gridGrouping.BackColor = SystemColors.Window;
			gridGrouping.TableModel.Rows.HeaderCount = 2;
			gridGrouping.Appearance.AnyHeaderCell.CellAppearance = GridCellAppearance.Flat;
			gridGrouping.Appearance.ColumnHeaderCell.Interior = new BrushInfo(GradientStyle.PathEllipse, Color.White, Color.Wheat);
		}

		#region column initialiser
		private void InitialiseColumns()
		{


			// GridColumnDescriptors
			GridColumnDescriptor desc1 = new GridColumnDescriptor();
			GridColumnDescriptor desc2 = new GridColumnDescriptor();
			GridColumnDescriptor desc3 = new GridColumnDescriptor();
			GridColumnDescriptor desc4 = new GridColumnDescriptor();
			GridColumnDescriptor desc5 = new GridColumnDescriptor();
			GridColumnDescriptor desc6 = new GridColumnDescriptor();
			GridColumnDescriptor desc7 = new GridColumnDescriptor();
			GridColumnDescriptor desc8 = new GridColumnDescriptor();
			GridColumnDescriptor desc9 = new GridColumnDescriptor();
			GridColumnDescriptor desc10 = new GridColumnDescriptor();
			GridColumnDescriptor desc11 = new GridColumnDescriptor();
			GridColumnDescriptor desc12 = new GridColumnDescriptor();
			GridColumnDescriptor desc13 = new GridColumnDescriptor();
			GridColumnDescriptor desc14 = new GridColumnDescriptor();
			GridColumnDescriptor desc15 = new GridColumnDescriptor();
			GridColumnDescriptor desc16 = new GridColumnDescriptor();
			GridColumnDescriptor desc17 = new GridColumnDescriptor();
			GridColumnDescriptor desc18 = new GridColumnDescriptor();
			GridColumnDescriptor desc19 = new GridColumnDescriptor();
			GridColumnDescriptor desc20 = new GridColumnDescriptor();
			GridColumnDescriptor desc21 = new GridColumnDescriptor();
			GridColumnDescriptor desc22 = new GridColumnDescriptor();

	
			desc1.MappingName = "C1";
			desc1.Width = 60;
	
			desc2.MappingName = "C2";
			desc2.Width = 60;
	
			desc3.MappingName = "C3";
			desc3.Width = 80;
			
			desc4.MappingName = "C4";
			desc4.Width = 80;


			desc5.MappingName = "C5";
			desc5.Width = 60;

			desc6.MappingName = "C6";
			desc6.Width = 60;

			desc7.MappingName = "C7";
			desc7.Width = 60;

			desc8.MappingName = "C8";
			desc8.Width = 40;

			desc9.MappingName = "C9";
			desc9.Width = 100;

			desc10.MappingName = "C10";
			desc10.Width = 60;
			
			desc11.MappingName = "C11";
			desc11.Width = 40;

			desc12.MappingName = "C12";
			desc12.Width = 65;

			desc13.MappingName = "C13";
			desc13.Width = 65;

			desc14.MappingName = "C14";
			desc14.Width = 100;

			desc15.MappingName = "C15";
			desc15.Width = 35;

			desc16.MappingName = "C16";
			desc16.Width = 35;
	
			desc17.MappingName = "C17";
			desc17.Width = 35;

			desc18.MappingName = "C18";
			desc18.Width = 35;

			desc19.MappingName = "C19";
			desc19.Width = 40;

			desc20.MappingName = "C20";
			desc20.Width =  35;

			desc21.MappingName = "C21";
			desc21.Width = 70;

			desc22.MappingName = "C22";
			desc22.Width = 70;


			this.gridGrouping.TableDescriptor.Columns.AddRange(
				new Syncfusion.Windows.Forms.Grid.Grouping.GridColumnDescriptor[] {
																					  desc1,
																					  desc2,
																					  desc3,
																					  desc4,
																					  desc5,
																					  desc6,
																					  desc7,
																					  desc8,
																					  desc9,
																					  desc10,
																					  desc11,
																					  desc12,
																					  desc13,
																					  desc14,
																					  desc15,
																					  desc16,
																					  desc17,
																					  desc18,
																					  desc19,
																					  desc20,
																					  desc21,
																					  desc22});


			// GridColumnDescriptorSet / Multi Row Headers

			GridColumnSetDescriptor setDesc1 = new GridColumnSetDescriptor();
			GridColumnSetDescriptor setDesc2 = new GridColumnSetDescriptor();
			GridColumnSetDescriptor setDesc3 = new GridColumnSetDescriptor();
			GridColumnSetDescriptor setDesc4 = new GridColumnSetDescriptor();
			GridColumnSetDescriptor setDesc5 = new GridColumnSetDescriptor();
			GridColumnSetDescriptor setDesc6 = new GridColumnSetDescriptor();
			GridColumnSetDescriptor setDesc7 = new GridColumnSetDescriptor();
			GridColumnSetDescriptor setDesc8 = new GridColumnSetDescriptor();
	


			setDesc1.Name = "C1";
			setDesc1.ColumnSpans.AddRange(new GridColumnSpanDescriptor[] {
																			 new GridColumnSpanDescriptor("C1", "R0C0"),
																			 new GridColumnSpanDescriptor("C2", "R1C0")});

			setDesc2.Name = "C3";
			setDesc2.ColumnSpans.AddRange(new GridColumnSpanDescriptor[] {
																			 new GridColumnSpanDescriptor("C3", "R0C0"),
																			 new GridColumnSpanDescriptor("C4", "R1C0")});

			setDesc3.Name = "C5";
			setDesc3.ColumnSpans.AddRange(new GridColumnSpanDescriptor[] {
																			 new GridColumnSpanDescriptor("C5", "R0C0"),
																			 new GridColumnSpanDescriptor("C6", "R0C1"),
																			 new GridColumnSpanDescriptor("C7", "R0C2"),
																			 new GridColumnSpanDescriptor("C8", "R0C3"),
																			 new GridColumnSpanDescriptor("C9","R1C0:R1C3")});


			setDesc4.Name = "C10";
			setDesc4.ColumnSpans.AddRange(new GridColumnSpanDescriptor[] {
																			 new GridColumnSpanDescriptor("C10", "R0C0"),
																			 new GridColumnSpanDescriptor("C11", "R1C0")});

			setDesc5.Name = "C12";
			setDesc5.ColumnSpans.AddRange(new GridColumnSpanDescriptor[] {
																			 new GridColumnSpanDescriptor("C12", "R0C0"),
																			 new GridColumnSpanDescriptor("C13", "R1C0")});

			setDesc6.Name = "C14";
			setDesc6.ColumnSpans.AddRange(new GridColumnSpanDescriptor[] {
																			 new GridColumnSpanDescriptor("C14", "R0C0:R0C3"),
																			 new GridColumnSpanDescriptor("C15", "R1C0"),
																			 new GridColumnSpanDescriptor("C16", "R1C1"),
																			 new GridColumnSpanDescriptor("C17", "R1C2"),
																			 new GridColumnSpanDescriptor("C18","R1C3")});

			setDesc7.Name = "C19";
			setDesc7.ColumnSpans.AddRange(new GridColumnSpanDescriptor[] {
																			 new GridColumnSpanDescriptor("C19", "R0C0"),
																			 new GridColumnSpanDescriptor("C20", "R1C0")});

			setDesc8.Name = "C21";
			setDesc8.ColumnSpans.AddRange(new GridColumnSpanDescriptor[] {
																			 new GridColumnSpanDescriptor("C21", "R0C0"),
																			 new GridColumnSpanDescriptor("C22", "R1C0")});

			this.gridGrouping.TableDescriptor.ColumnSets.AddRange(new GridColumnSetDescriptor[]
													{
														setDesc1,
														setDesc2,
														setDesc3,
														setDesc4,
														setDesc5,
														setDesc6,
														setDesc7,
														setDesc8});



		}
		#endregion



		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}
		private void gridGrouping_TableControlCurrentCellChanged(object sender, GridTableControlEventArgs e)
		{

			
			int colIndex = e.TableControl.CurrentCell.ColIndex;
			int rowIndex = e.TableControl.CurrentCell.RowIndex;

			int level = e.TableControl.Table.GroupLevel;

			bool isGrouped = this.gridGrouping.TableDescriptor.IsGrouped;



			GridTableCellStyleInfo style = e.TableControl.Model[colIndex, rowIndex];

			// The identity contains all information about group, column, displayelement etc.

			GridColumnDescriptor column = style.TableCellIdentity.Column;
			// To get the relative row/col for for a column descriptor in multi-row scenarion:

			int resultCol, resultRow; 
			e.TableControl.TableDescriptor.ColumnToRowColIndex(column.Name, out resultRow, out resultCol);
			Console.WriteLine("colIndex={0}, rowIndex={1}, columnName={2}, resultRow={3}, resultCol={4} ", colIndex, rowIndex,column.Name, resultRow, resultCol);
	
		}





		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			this.Size = new System.Drawing.Size(300,300);
			this.Text = "Form1";
		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}
	}
}
